#define DIM 200
#define MAX_POW 50

void mat_print (double m[DIM][DIM])
{

  int row, col;

  printf ("%8c", ' ');

  for (col = 0; col < DIM; col++)
    printf ("%8d", col);

  printf ("\n");

  for (row = 0; row < DIM; row ++) {
    printf ("%6d  ", row);

    for (col = 0; col < DIM; col++) {
      printf ("%4E%2c", m[row][col], ' ');
    }

    printf ("\n");
  }

}


float row_compute (double m1[DIM][DIM], double m2[DIM][DIM], int row, int col)
{
  double tmp = 0.0;

  int i;

  for (i = 0; i < DIM; i++)
    tmp += m1[row][i] * m2[i][col];

  return tmp;
}

void load(double m[DIM][DIM])
{
  int i, j;

  for (i = 0; i < DIM; i++)
    for (j = 0; j < DIM; j++)
       m[i][j] = ((i == j) ? 1.0 : 0.0);


/*    mat_print(m); */
}

int main ()
{

  double m1[DIM][DIM], m2[DIM][DIM], correctm[DIM][DIM];

  int pow, i, j;

  load(m1);
/*    mat_print(m1); */

  for (pow = 1; pow < MAX_POW; pow++) {

    for (i = 0; i < DIM; i++) {
      for (j = 0; j < DIM; j++) {
	m2[i][j] = row_compute (m1, m1, i, j);
      }
    }

/*      mat_print (m1); */
    memcpy (m1, m2, sizeof (m1));
/*      printf ("iteration %d\n", pow); */
  }

  for (i = 0; i < DIM; i++) {
    for (j = 0; j < DIM; j ++) {
      if (i == j) {
	if (m1[i][j] != 1.0) {
	  printf ("Mat_mult: wrong result in matrix.\n");
	  printf ("m1[%d,%d]=%f, should be 1.0.\n", i, j, m1[i][j]);
	  exit (-1);
	}
      } /* if */
      else {
	if (m1[i][j] != 0.0) {
	  printf ("Mat_mult: wrong result in matrix.\n"); 
	  printf ("m1[%d,%d]=%f, should be 0.0.\n", i, j, m1[i][j]);
	  exit (-1);
	}
      } /* else */
    } /* for j... */
  } /* for i... */

  exit (0);
}
