/*******************************************
  Truncate a given file to a specified length
  
  Usage:
  truncate <file_name> <length>

Written by Hans Reiser.
Modified to loop and check file size with stat by Bob Matthews


********************************************/

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main (int argc, char * argv []) 
{
  int fd;
  off_t pos;
  struct stat *stat_buf = (struct stat *) malloc (sizeof (struct stat));

  if (argc != 3) {
    printf ("Usage: %s [file_name] [length]\n", argv [0]);
    exit (0);
  }

  // open existing, or CREATE not existing file
  if ((fd = open (argv[1], O_RDWR | O_CREAT, 0644)) == -1) {
    perror ("open failed : ");
    return 1;
  }

  for (pos = (off_t)strtoll( argv [2], NULL, 0) ; pos >= 0 ; pos-- ) {

    if (ftruncate(fd, (off_t)pos) != 0){
      perror ("truncate failed : ");
      return 1;
    }
    
    if (fstat (fd, stat_buf) == -1) {
      perror ("stat failed : ");
      return 1;
    }
    
    if (stat_buf->st_size != (off_t) pos) {
      printf ("file size = %x is wrong after ftruncate\n", (int) pos);
      perror ("ftruncate or stat : ");
      return 1;
    }
  }

  exit (0);


}
