#
# A driver file for the rawio test.
#
# Usage: rawio <raw_device> <block_device> <temporary file>
#

TMPDIR=/tmp
RAW_DEVICE=$1
BLOCK_DEVICE=$2

trap "rm -rf $TMPFILE >> /dev/null 2>&1; exit 0" SIGINT SIGHUP SIGTERM

TMPFILE=`mktemp "$TMPDIR"/rawio.XXXXXX`
[ $? -eq 0 ] || { echo "Can't make temporary file." ; exit -1 ; }

cd rawio >> /dev/null 2>&1
[ $? -eq 0 ] || { echo "Can't cd to rawio dir." ; exit -1 ;  }

./rawio "$RAW_DEVICE" "$BLOCK_DEVICE" "$TMPFILE"
[ $? -eq 0 ] || { echo "RAWIO on raw device $RAW_DEVICE failed." ; rm -rf "$TMPFILE" ; exit -1 ; }

rm -rf "$TMPFILE" 2>&1 /dev/null
[ $? -eq 0 ] || { echo "Could not remove $TMPFILE." ; exit -1 ; }

exit 0

