#!/bin/sh

LOCAL_HOST=$1
REMOTE_HOST=$2

#
# Start receiver, remember its pid
#
./ttcp -r $REMOTE_HOST &
RECEIVER=$!

trap "kill $RECEIVER; exit -1" SIGINT SIGHUP SIGTERM

#
# Give receiver some time to start up
#
# 10 seconds is probably too long in most cases, but I've seen some 
# odd failures on heavily loaded systems.
#
sleep 10

#
#Start sender
#
./ttcp -t -n65536 $LOCAL_HOST
RET_VAL=$?
kill $RECEIVER >> /dev/null 2>&1

trap "" SIGINT SIGHUP SIGTERM

# We are seeing some intermittent failures in the ttcp test.  It appears that
# the kernel isn't releasing the receiver's socket quickly enough.  This
# causes the receiver to see a "bind: Address already in use" error.  So,
# we need to sleep here while the kernel cleans up.  Again, 10 seconds
# is probably too long for most cases, but will avoid any false positives.
sleep 10

exit $RET_VAL

